/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.51 from the
 * contents of WireGuard.xs. Do not edit this file, edit WireGuard.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "WireGuard.xs"
#include "easyxs/easyxs.h"

#include "wireguard.h"

#define PERL_NS "Linux::WireGuard"

#define IPV4_STRLEN sizeof( ((struct sockaddr_in*) NULL)->sin_addr.s_addr)
#define IPV6_STRLEN sizeof( ((struct sockaddr_in6*) NULL)->sin6_addr)

static HV* _wgallowedip_to_hv (pTHX_ wg_allowedip* allowedip) {
    HV* ip_hv = newHV();

    hv_stores(ip_hv, "family", newSVuv(allowedip->family));

    SV* addr_sv = NULL;

    switch (allowedip->family) {
        case AF_INET:
            addr_sv = newSVpvn((char*) &allowedip->ip4.s_addr, IPV4_STRLEN);
            break;
        case AF_INET6:
            addr_sv = newSVpvn((char*) &allowedip->ip6.s6_addr, IPV6_STRLEN);
            break;
        default:
            assert(0);
    }

    hv_stores(ip_hv, "addr", addr_sv);
    hv_stores(ip_hv, "cidr", newSVuv(allowedip->cidr));

    return ip_hv;
}

static HV* _wgpeer_to_hv (pTHX_ wg_peer *peer) {
    wg_allowedip* allowedip;

    HV* hv = newHV();

    // hv_stores(hv, "flags", newSViv(peer->flags));

    hv_stores(hv, "public_key", (peer->flags & WGPEER_HAS_PUBLIC_KEY) ? newSVpvn((char*) peer->public_key, sizeof(peer->public_key)) : &PL_sv_undef);
    hv_stores(hv, "preshared_key", (peer->flags & WGPEER_HAS_PRESHARED_KEY) ? newSVpvn( (char*) peer->preshared_key, sizeof(peer->preshared_key)) : &PL_sv_undef);

    unsigned endpoint_len = 0;
    switch (peer->endpoint.addr.sa_family) {
        case 0:
            break;
        case AF_INET:
            endpoint_len = sizeof(struct sockaddr_in);
            break;
        case AF_INET6:
            endpoint_len = sizeof(struct sockaddr_in6);
            break;
        default:
            assert(0);
    }

    hv_stores(hv, "endpoint", endpoint_len ? newSVpvn((char*) &peer->endpoint, endpoint_len) : &PL_sv_undef);

    hv_stores(hv, "rx_bytes", newSVuv(peer->rx_bytes));
    hv_stores(hv, "tx_bytes", newSVuv(peer->tx_bytes));
    hv_stores(hv, "persistent_keepalive_interval", (peer->flags & WGPEER_HAS_PERSISTENT_KEEPALIVE_INTERVAL) ? newSVuv(peer->persistent_keepalive_interval) : &PL_sv_undef);

    hv_stores(hv, "last_handshake_time_sec", newSViv(peer->last_handshake_time.tv_sec));
    hv_stores(hv, "last_handshake_time_nsec", newSViv(peer->last_handshake_time.tv_nsec));

    AV* allowed_ips = newAV();
    hv_stores(hv, "allowed_ips", newRV_noinc((SV*) allowed_ips));

    wg_for_each_allowedip(peer, allowedip) {
        HV* ip_hv = _wgallowedip_to_hv(aTHX_ allowedip);
        av_push(allowed_ips, newRV_noinc((SV*)ip_hv));
    }

    return hv;
}

static HV* _wgdev_to_hv (pTHX_ wg_device *dev) {
    wg_peer *peer;

    HV* dev_hv = newHV();

    hv_stores(dev_hv, "name", newSVpv(dev->name, 0));
    hv_stores(dev_hv, "ifindex", newSVuv(dev->ifindex));

    // hv_stores(dev_hv, "flags", newSViv(dev->flags));

    hv_stores(dev_hv, "public_key", dev->flags & WGDEVICE_HAS_PUBLIC_KEY ? newSVpvn((char*) dev->public_key, sizeof(dev->public_key)) : &PL_sv_undef);
    hv_stores(dev_hv, "private_key", dev->flags & WGDEVICE_HAS_PRIVATE_KEY ? newSVpvn((char*) dev->private_key, sizeof(dev->private_key)) : &PL_sv_undef);

    hv_stores(dev_hv, "fwmark", dev->flags & WGDEVICE_HAS_FWMARK ? newSVuv(dev->fwmark) : &PL_sv_undef);
    hv_stores(dev_hv, "listen_port", dev->flags & WGDEVICE_HAS_LISTEN_PORT ? newSVuv(dev->listen_port) : &PL_sv_undef);

    AV* peers = newAV();
    hv_stores(dev_hv, "peers", newRV_noinc((SV*) peers));

    wg_for_each_peer(dev, peer) {
        HV* peer_hv = _wgpeer_to_hv(aTHX_ peer);
        av_push(peers, newRV_noinc((SV*) peer_hv));
    }

    return dev_hv;
}

// Doesn’t seem to be useful:
#define _LWG_CREATE_CONST_UV(ns, theconst) \
    newCONSTSUB(gv_stashpv(ns, 0), #theconst, newSVuv(theconst));

// ----------------------------------------------------------------------

#line 121 "WireGuard.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 265 "WireGuard.c"

XS_EUPXS(XS_Linux__WireGuard_list_device_names); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__WireGuard_list_device_names)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 118 "WireGuard.xs"
        char *device_names, *device_name;
        size_t len;

        device_names = wg_list_device_names();
        if (!device_names) {
            croak("Failed to retrieve device names: %s", strerror(errno));
        }

        unsigned count=0;

        wg_for_each_device_name(device_names, device_name, len) {
            count++;
            mXPUSHp(device_name, len);
        }

        free(device_names);

        XSRETURN(count);
#line 295 "WireGuard.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Linux__WireGuard_get_device); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__WireGuard_get_device)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "name_sv");
    {
	SV *	RETVAL;
	SV*	name_sv = ST(0)
;
#line 140 "WireGuard.xs"
        wg_device *dev;

        const char* devname = exs_SvPVbyte_nolen(name_sv);

        if (wg_get_device(&dev, devname) < 0) {
            croak("Failed to retrieve device `%s`: %s", devname, strerror(errno));
        }

        HV* dev_hv = _wgdev_to_hv(aTHX_ dev);

        wg_free_device(dev);

        RETVAL = newRV_noinc((SV*) dev_hv);

#line 327 "WireGuard.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Linux__WireGuard_add_device); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__WireGuard_add_device)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "name_sv");
    {
	SV*	name_sv = ST(0)
;
#line 162 "WireGuard.xs"
        const char* devname = exs_SvPVbyte_nolen(name_sv);

        int result = ix ? wg_del_device(devname) : wg_add_device(devname);
        if (result) {
            croak("Failed to %s device `%s`: %s", ix ? "delete" : "add", devname, strerror(errno));
        }
#line 352 "WireGuard.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Linux__WireGuard_generate_private_key); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__WireGuard_generate_private_key)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 174 "WireGuard.xs"
        wg_key key;

        if (ix) {
            wg_generate_preshared_key(key);
        }
        else {
            wg_generate_private_key(key);
        }

        RETVAL = newSVpv((char*) key, sizeof(wg_key));
#line 378 "WireGuard.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Linux__WireGuard_generate_public_key); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__WireGuard_generate_public_key)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "private_key_sv");
    {
	SV *	RETVAL;
	SV*	private_key_sv = ST(0)
;
#line 190 "WireGuard.xs"
        wg_key public_key;

        if (SvROK(private_key_sv)) {
            croak("Reference is nonsensical here!");
        }

        STRLEN keylen;
        const char* private_key_char = SvPVbyte(private_key_sv, keylen);

        if (keylen != sizeof(wg_key)) {
            croak("Key must be exactly %lu characters, not %lu!", sizeof(wg_key), keylen);
        }

        wg_generate_public_key(public_key, (const void*) private_key_char);

        RETVAL = newSVpv((char*) public_key, sizeof(wg_key));
#line 413 "WireGuard.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C" {
#endif
XS_EXTERNAL(boot_Linux__WireGuard); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Linux__WireGuard)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Linux::WireGuard::list_device_names", XS_Linux__WireGuard_list_device_names);
        newXS_deffile("Linux::WireGuard::get_device", XS_Linux__WireGuard_get_device);
        cv = newXS_deffile("Linux::WireGuard::add_device", XS_Linux__WireGuard_add_device);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("Linux::WireGuard::del_device", XS_Linux__WireGuard_add_device);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("Linux::WireGuard::generate_preshared_key", XS_Linux__WireGuard_generate_private_key);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("Linux::WireGuard::generate_private_key", XS_Linux__WireGuard_generate_private_key);
        XSANY.any_i32 = 0;
        newXS_deffile("Linux::WireGuard::generate_public_key", XS_Linux__WireGuard_generate_public_key);
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

#ifdef __cplusplus
}
#endif
